Page MenuHomePhabricator

Allow multiple replies to be drafted at the same time
Open, Needs TriagePublic

Description

There were two reasons not to do this initially:

  • Saving the first draft would re-render the page, so all other drafts would be lost. This isn't an issue anymore with auto-save.
  • The document-to-save is composed in the client, and there is only one copy (for memory efficiency), so there could be cases where a failed save, or two saves in quick succession could result in multiple changes being pushed in one edit. This would be resolved by using a server-side API that will process multiple saves in completely separate contexts: T252558

Testing details

(moved from T252558)

  • "Sequence" to test:
    • Action: click [ Reply ] on many comments on a single page, write comments in each of the open Reply Tools and post one of them.
    • Outcome: ensure said comment was posted correctly and upon the page being reloaded, the comments you had drafted are still intact.

Event Timeline

Esanders created this task.Jul 7 2020, 11:33 AM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJul 7 2020, 11:33 AM

Change 609849 had a related patch set uploaded (by Esanders; owner: Esanders):
[mediawiki/extensions/DiscussionTools@master] Allow multiple replies to be open at once

https://gerrit.wikimedia.org/r/609849

Esanders claimed this task.Jul 15 2020, 3:54 PM
matmarex updated the task description. (Show Details)Jul 27 2020, 11:14 PM

@ppelberg will spin up a patch demo for this task.

@ppelberg will spin up a patch demo for this task.

Patch demo is here: http://patchdemo.wmflabs.org/wikis/362d321be70b707e2711ee521927aae8/w/index.php/Talk:Main_Page

Next steps

  • @ppelberg to comment feedback and if necessary, file tickets for follow ons.
ppelberg added a comment.EditedAug 6 2020, 7:50 PM

Next steps

  • @ppelberg to comment feedback and if necessary, file tickets for follow ons.

Ed, this works well. Two things below: a question for us to answer now and an issue for us to address later.

Now

  • Why is that the browser warning [i] is being shown to people when attempting to leave the talk page under the below conditions? This does not seem to be happening on beta.
    • 1 or more Reply Tools are open
    • Said Reply Tool(s) do NOT have any text entered into them

Later

  • I wonder whether it being possible to have multiple Reply Tools open in close proximity to one another will amplify the issue we documented earlier [ii]: It can be difficult for people understand the relationship between the Reply Tool and the comment they are responding to.
    • I've filed a ticket specifically for this issue: T259834

i.


ii. See T254208, "Issue #5"

Why is that the browser warning [i] is being shown to people when attempting to leave the talk page

If I open two widgets and hit reload I don't see the warning, even if I populate then clear them. If you can reproduce this can you provide more detailed reproduction steps?

Also can you reproduce here: http://patchdemo.wmflabs.org/wikis/21392cea89afbeac79083c171c1b12ff/w/index.php/Talk:Main_Page

I can open multiple widgets. When I save one of them widgets with text already entered remain open, and the text is retained. Widgets with no text in them are closed. I didn't expect the latter.

I can't reproduce this error.

Agree with @ppelberg re:

I wonder whether it being possible to have multiple Reply Tools open in close proximity to one another will amplify the issue we documented earlier [ii]: It can be difficult for people understand the relationship between the Reply Tool and the comment they are responding to.

Glad to address this later in the other ticket, just want to give a +1 and speculate the with some of the tweaks we are making to the page in conjunction with the visual refresh as well as the New Discussion, there will be a need to look into a systematic approach.

If I open two widgets and hit reload I don't see the warning, even if I populate then clear them. If you can reproduce this can you provide more detailed reproduction steps?

Also can you reproduce here: http://patchdemo.wmflabs.org/wikis/21392cea89afbeac79083c171c1b12ff/w/index.php/Talk:Main_Page

Huh, I'm no longer able to reproduce this. Let's let this go.

I can open multiple widgets. When I save one of them widgets with text already entered remain open, and the text is retained. Widgets with no text in them are closed. I didn't expect the latter.

This is helpful, @AdHuikeshoven. A follow up question for you: Can you think of a situation in which you'd encounter the scenario you described [i]?

In asking the above, I'm trying to better understand where the expectation you shared might be coming from.

For context, here's how I'm currently thinking about it:

  • The Reply Tool should do it's best to preserve peoples' effort/progress
  • "Effort"/"progress" in this context means they've typed something into the Reply Tool for it is a strong proxy for them having invested some amount of time/energy into posting a comment to the talk page

[i]. Scenario:

  1. Open multiple Reply Tools on the same page (call them "RT-1" and "RT-2")
  2. Draft a comment in RT-1, RT-2 remains "empty"
  3. Post the comment you drafted in RT-1
  4. Upon the page reloading, notice: the comment you drafted in RT-1 has been published to the page AND RT-2 is closed

Decided

  • Before implementing multiple Reply Tools being open at once, we need to first make it so people can clearly understand the relationship between the comment they are writing [in the Reply Tool] and the comment they are responding to. This work will happen in this task: T259834
    • Reason: were we to implement what this task is suggesting, we increase the likelihood of peoples' comments being posted in a position within the conversation they did not expect. This could lead people to lose trust and confidence in the Reply Tool.

Resulting action

  • Move this task – T257305 – to the backlog and prioritize T259834.